<?php
/** @var \Xcoding\ProductSizing\Block\Adminhtml\Edit\Form $block */
?>
<table style="width: 900px; margin:auto" id="sizing_table" data-config='<?= $block->getConfigJson() ?>'>
    <thead>
        <tr class="header">
            <?php for ($i=0; $i < $block::COLUMN_QTY; $i++) : ?>
                <td>
                    <select class="admin__control-select table_header" data-column="<?= $i ?>">
                        <option value="0">---</option>
                        <?php foreach (\Xcoding\ProductSizing\Model\ProductSizing::HEADERS as $id => $label) : ?>
                            <option value="<?= $id ?>"><?= $label ?></option>
                        <?php endforeach; ?>
                    </select>
                </td>
            <?php endfor; ?>
            <td><?= __('Actions') ?></td>
        </tr>
    </thead>
    <tbody></tbody>
    <tfoot>
        <tr>
            <?php for ($i=0; $i < $block::COLUMN_QTY; $i++) : ?>
                <td></td>
            <?php endfor; ?>
            <td>
                <button type="button" class="action-basic primary add_new" style="width: 100%;">Add new row</button>
            </td>
        </tr>
    </tfoot>
</table>

<script>
class SizingContent {
    maxColumnQty = 5;

    constructor() {
        this.table = document.getElementById("sizing_table");
        try {
            this.config = JSON.parse(this.table.dataset.config);
        } catch(e) {
            this.config = new Object();
            this.config.columns = [];
            this.config.rows = [];
        }
        this.bindEvents();
        this.rebuildForm();
        this.updateContent();
    }

    bindEvents() {
        this.table.getElementsByClassName("add_new")[0].onclick = () => { 
            this.addNewRow();
        };
        Array.from(this.table.getElementsByTagName('select')).forEach(el => {
            el.onchange = () => { this.rebuildConfig(); }
        });
    }

    addNewRow(values) {
        let tr = document.createElement("tr");
        let tbody = this.table.getElementsByTagName("tbody")[0];
        for (let i = 0; i < this.maxColumnQty; i++) {
            let td = document.createElement("td");
            let input = document.createElement("input");
            input.className = "admin__control-text";
            input.maxLength = 255;
            input.style = "width: 145px";
            if ((typeof values !== 'undefined') && (typeof values[i] !== 'undefined')) {
                input.value = values[i];
            }
            input.onfocusout = () => {
                this.rebuildConfig();
            }
            td.appendChild(input);
            tr.appendChild(td);
        }
        let td = document.createElement("td");
        let button = document.createElement("button");
        button.className = "action-basic";
        button.innerHTML = "Delete";
        button.style = "width: 100%";
        button.onclick = () => {
            this.deleteRow(tr);
        }
        td.appendChild(button);
        tr.appendChild(td);
        tbody.appendChild(tr);
    }

    deleteRow(tr) {
        tr.remove();
        this.rebuildConfig();
    }

    rebuildConfig() {
        this.config = new Object();
        let columns = 0;

        // build headers config
        let headers = Array.from(this.table.getElementsByTagName('thead')[0].getElementsByTagName('select'));
        let headersData = [];
        headers.forEach(select => {
            if (select.value > 0) {
                headersData.push(select.value);
                columns++;
            }
        });
        this.config.columns = columns;
        this.config.headers = headersData;

        // build rows config
        let rows = Array.from(this.table.getElementsByTagName('tbody')[0].getElementsByTagName('tr'));
        let rowsData = [];
        rows.forEach(tr => {
            let rowData = [];
            let inputs = Array.from(tr.getElementsByTagName('input'));
            for (let i = 0; i < columns; i++) {
                rowData.push(inputs[i].value);
            }
            rowsData.push(rowData);
        });
        this.config.rows = rowsData;

        this.updateContent();
    }

    rebuildForm() {
        // build headers
        let headers = Array.from(this.table.getElementsByTagName('thead')[0].getElementsByTagName('select'));
        for (let i = 0; i < this.config.columns; i++) {
            headers[i].value = this.config.headers[i];
        }

        // build rows
        let tbody = this.table.getElementsByTagName('tbody')[0];
        tbody.innerHTML = "";
        this.config.rows.forEach(rowValues => {
            this.addNewRow(rowValues);
        })
    }

    updateContent() {
        let input = document.getElementsByName("content_json")[0];
        if (typeof input !== 'undefined') {
            input.value = JSON.stringify(this.config);
            var event = new Event('change');
            input.dispatchEvent(event);
        }
    }
}

document.addEventListener("DOMContentLoaded", function() {
    new SizingContent();
});
</script>